#![allow(deprecated)]
use std::fmt;
use std::str;
/// The order in which the histogram should be sorted.
/// Default is VALUE_ASCENDING.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum HistogramSortOrder {
    #[serde(rename = "VALUE_ASCENDING")]
    ValueAscending,
    #[serde(rename = "VALUE_DESCENDING")]
    ValueDescending,
    #[serde(rename = "FREQUENCY_ASCENDING")]
    FrequencyAscending,
    #[serde(rename = "FREQUENCY_DESCENDING")]
    FrequencyDescending,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl HistogramSortOrder {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            HistogramSortOrder::ValueAscending => "VALUE_ASCENDING",
            HistogramSortOrder::ValueDescending => "VALUE_DESCENDING",
            HistogramSortOrder::FrequencyAscending => "FREQUENCY_ASCENDING",
            HistogramSortOrder::FrequencyDescending => "FREQUENCY_DESCENDING",
            HistogramSortOrder::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for HistogramSortOrder {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for HistogramSortOrder {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for HistogramSortOrder {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<HistogramSortOrder, conjure_object::plain::ParseEnumError> {
        match v {
            "VALUE_ASCENDING" => Ok(HistogramSortOrder::ValueAscending),
            "VALUE_DESCENDING" => Ok(HistogramSortOrder::ValueDescending),
            "FREQUENCY_ASCENDING" => Ok(HistogramSortOrder::FrequencyAscending),
            "FREQUENCY_DESCENDING" => Ok(HistogramSortOrder::FrequencyDescending),
            v => v.parse().map(|v| HistogramSortOrder::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for HistogramSortOrder {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<HistogramSortOrder, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the HistogramSortOrder enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
